PROGRAM Test;
USES Crt, Objects, TVSorts;

CONST
  MaxCollectionSize = 10;

VAR C : TCollection;
    i, j, k : Integer;
    Ch : ^Char;

BEGIN
  Randomize;
  FOR i := 1 TO 11 DO
    BEGIN
        { initialize collection and load with data in reverse order }
      C.Init(MaxCollectionSize,1);
      FOR j := MaxCollectionSize DOWNTO 0 DO
          BEGIN
            k := Random(255);
            WHILE (k < 65) OR (k > 90) DO k := Random(255);
            New(Ch);
            Ch^ := Char(k);
            C.AtInsert(0,Ch);
          END;
        { display unsorted data }
      ClrScr;
      CASE i OF
        1 : WriteLn('Binary Insertion Sort');
        2 : WriteLn('Bubble Sort');
        3 : WriteLn('Comb Sort');
        4 : WriteLn('Heap Sort');
        5 : WriteLn('Quick Sort');
        6 : WriteLn('Non-recursive Quick Sort');
        7 : WriteLn('Shaker Sort');
        8 : WriteLn('Shell Sort');
        9 : WriteLn('Straight Insertion Sort');
       10 : WriteLn('Straight Selection Sort');
       11 : WriteLn('Tree Sort');
      END;
      FOR j := 0 TO (C.Count - 1) DO Write(Char(C.At(j)^):2);
        { sort data }
      CASE i OF
        1 : BinaryInsertionSort(@C,CompareChars);
        2 : BubbleSort(@C,CompareChars);
        3 : CombSort(@C,CompareChars);
        4 : HeapSort(@C,CompareChars);
        5 : QuickSort(@C,CompareChars);
        6 : QuickSortNonRecursive(@C,CompareChars);
        7 : ShakerSort(@C,CompareChars);
        8 : ShellSort(@C,CompareChars);
        9 : StraightInsertionSort(@C,CompareChars);
       10 : StraightSelectionSort(@C,CompareChars);
       11 : TreeSort(@C,CompareChars);
      END;
        { display sorted data }
      WriteLn;
      FOR j := 0 TO (C.Count - 1) DO Write(Char(C.At(j)^):2);
      ReadLn;
        { clear of collection }
    END;
END.